#!/usr/local/bin/perl

$debug = 0;
# Default Cordinates
#    x1 = a*x+c*y+x
#    y1 = b*x+d*y+y
&initCord;

$d = '([-+0-9.e]+)';  # partern of number

# No tags for top level
$ctag = 0;
@tags = ();  
@color = (0,0,0);  
# @bb = (0,0,100,100);  # bounding box

while(<>) {
  chop;
  if (/^\%\%BoundingBox: (\d+) (\d+) (\d+) (\d+)/) { 
     $bb1[0] = int($ac*$1 + $cc*$2 + $xc);
     $bb1[3] = int($bc*$1 + $dc*$2 + $yc);
     $bb1[2] = int($ac*$3 + $cc*$4 + $xc);
     $bb1[1] = int($bc*$3 + $dc*$4 + $yc);
  } elsif (/^\%I Idraw/) { 
     &header;
  # Argument part
  } elsif (/%I b (.*)/) { $brush = $1;
     if(/none SetP %I p n/) {
        next;
     }
     $_ = <>; 
     if(/(\d+) (\d+) (\d+) \[(\d+) (\d+)\] (\d+) SetB/) {
        ($lwidth,$farrow,$larrow,$dash,$dasho,$ltype) = ($1,$2,$3,$4,$5,$6);
     } elsif(/(\d+) (\d+) (\d+) \[\] (\d+) SetB/) {
        ($lwidth,$farrow,$larrow,$ltype) = ($1,$2,$3,$4);
        $dash = 0; $dasho = 0;
     } 
  } elsif (/%I cfg (.*)/) { 
     next if ($1 eq "u");
     $_ = <>; @color = /([-.\d]+)/g; 
     $front_color = &color(@color);
  } elsif (/%I cbg (.*)/) { 
     next if ($1 eq "u");
     $_ = <>; @color = /([-.\d]+)/g; 
     $back_color = &color(@color);
  } elsif (/%I f (.*)/) {  $font = $1; 
     next if ($1 eq "u");
     $kanji = ($font =~ /jisx0208/)?1:0;
     $font =~ s/ /\\ /g;
  } elsif (/%I p n/) {     $pattern = "none";
  } elsif (/%I p (.*)/) {  $pattern = $1;
  } elsif (/%I p$/) {  
     $_ = <>; /([-.\d]+)/; $pattern = $1;
  } elsif (/%I t u/) {
     ($ac,$bc,$cc,$dc,$xc,$yc) =  ($ab,$bb,$cb,$db,$xb,$yb);
  } elsif (/%I t$/) { $_ = <>; 
#    (ab,bb,...)   base   translation
#    (al,bl,...)   local  translation
#    (ac,bc,...)   curret translation
     ($al,$bl,$cl,$dl,$xl,$yl) = 
     /\[ $d $d $d $d $d $d \] concat/o;
#    Calculate new current translation (easy. ha?)
#    x2 = ab*(al*x+cl*y+xl)+cb*(bl*x+dl*y+yl)+xb,
#    y2 = bb*(al*x+cl*y+xl)+db*(bl*x+dl*y+yl)+yb 
    ($ac,$bc,$cc,$dc,$xc,$yc) = 
    ($al*$ab+$cb*$bl,    $bb*$al+$db*$bl, 
     $ab*$cl+$cb*$dl,    $bb*$cl+$db*$dl,
     $ab*$xl+$cb*$yl+$xb,$bb*$xl+$db*$yl+$yb);
     if($type eq 'Pict' || $type eq 'Idraw') {
        # Change Base Translation
        ($ab,$bb,$cb,$db,$xb,$yb) = ($ac,$bc,$cc,$dc,$xc,$yc);
        $type = '';
     }
     print "### Cord $ac,$bc,$cc,$dc,$xc,$yc\n" if $debug;
  # Group part
  } elsif(/%I Pict/) {
     $type = 'Pict';
     $brush = $front_color = $back_color =  $font = 'n';
     push(@cord,$ab,$bb,$cb,$db,$xb,$yb);
     push(@tags,'t' . $ctag++);
     print "### Begin Pict\n" if $debug;
  } elsif(/%I eop/) {   # Pop global translation in reverse order
     if(@cord) {
	 pop(@tags) if (@tags);
	 $yb = pop(@cord); $xb = pop(@cord);
	 $db = pop(@cord); $cb = pop(@cord);
	 $bb = pop(@cord); $ab = pop(@cord);
     } else {
         &initCord;
     }
     print "### End Pict\n" if $debug;
  # Item part
  } elsif(/%I (Text|Line|MLine|Poly|Rect|Elli|CBSpl|BSpl|Idraw|Circ)/) {
     $type = $1; @points = (); $pattern = 'none';
     $brush = 1;
     $front_color = 'Black';
     $back_color =  'White';
     $font = "-*-times-medium-r-normal--12-*-iso8859-1";
     $pattern = 'none';
     ($al,$bl,$cl,$dl,$xl,$yl) = (1,0,0,1,0,0);
     print "### Begin $type\n" if $debug;
  } elsif(/^%I ([-\d]+)$/||/^%I$/) {
     print "### Data of $type\n" if $debug;
     if($type eq 'Text') {
        $_ = <>; $text = '';
        while(<>) {
            last if (! /^\(/);
            s/^\(//; chop; chop;
            s/\\([()])/$1/g; 
            $text .= $_ . "\n";
        }
        chop($text);
        if ($kanji) {
#            $text =~ s/\$/\\\$/g;
	    $text = '"' . "\033\$B" . $text . "\033\(B" . '"';
            $text =~ s/\n/\033\(B\n\033\$B/g;
	} else {
            $text =~ s/(\$|\"|\\|\[|\])/\\$1/g; 
	    $text =~ s/\\\\(\d\d\d)/\\\1/g;
#            $text =~ s/\n/\\n/g; 
	    $text = '"' . $text . '"';
	}
	if ($font eq 'n' || $font =~ /Times/) {
	   $fontsize = ($font =~ /(\d+)/)? $1 : 12;
	   $font = "-*-times-medium-r-normal--$fontsize-*-iso8859-1";
	}
        print '$c->create("text"';&points(0,0); 
        print ',-text=>',$text,',-font=>"',$font,'",-anchor=>"w"';
        print ',-tag=>["',join('","',@tags),'"]' if(@tags);
     } elsif($type eq 'Line') {
        if($brush eq 'n') { next; }
	$_ = <>; @points = /$d $d $d $d Line/o;
        print '$c->create("line"'; 
        &points($points[0],$points[1]); 
        &points($points[2],$points[3]); 
        &linetype;
     } elsif($type eq 'BSpl' || $type eq 'MLine') {
        if($brush eq 'n') { next; }
        print '$c->create("line"'; 
        while(<>) {
           last if(/[-\d]+ (BSpl|MLine)/);
           if(/^$d $d/o) {
              &points($1,$2);
           }
        }
        &linetype;
        print  ',-smooth=>"true"' if ($type eq 'BSpl');
     } elsif($type eq 'CBSpl' || $type eq 'Poly') {
        if($type eq 'Poly' && $pattern eq 'none' && $brush ne 'n') {
          print '$c->create("line"'; 
          while(<>) {
             if(/^$d $d/o) { @buf = ($1,$2); last; }
	  }
          &points(@buf);
          while(<>) {
             last if(/[-\d]+ (CBSpl|Poly)/);
             if(/^$d $d/o) {
                &points($1,$2);
             }
          }
          &points(@buf);
          $larrow = $farrow = 0; $pattern  = 0;
          &linetype;
        } elsif($type eq 'CBSpl' && $pattern eq 'none' && $brush ne 'n') {
          # we have to simulate colsed spline using open spline
          # otherwise it becomes solid filled region
          @buf = ();
          print '$c->create("line"'; 
          while(<>) { if(/^$d $d/o) { @buf = ($1,$2);   last; } }
          while(<>) { if(/^$d $d/o) { push(@buf,$1,$2); last; } }
          &points($buf[2],$buf[3]);
          while(<>) {
             last if(/[-\d]+ CBSpl/);
             if(/^$d $d/o) {
                $x = $1; $y = $2; &points($1,$2);
             }
          }
          # ugly simulation, but better than nothing
          @mid = (($buf[0]+$x)/2,($buf[1]+$y)/2);
          &points($mid[0],$mid[1]);
          &points($buf[0],$buf[1]);
          &points($buf[2],$buf[3]);
          $larrow = $farrow = 0; $pattern  = 0;
          &linetype;
          print ',-smooth=>"true"';
        } else {
          print '$c->create("polygon"'; 
          while(<>) {
             last if(/[-\d]+ (CBSpl|Poly)/);
             if(/^$d $d/o) {
                &points($1,$2);
             }
          }
          $larrow = $farrow = 0; $lwidth=0; 
          print ',-smooth=>"true"' if ($type eq 'CBSpl');
          &linetype;        # no support for -width
        }
     } elsif($type eq 'Rect') {
        if($brush eq 'n' && ! $area_fill ) { next; }
	$_ = <>; @points = /$d $d $d $d Rect/o;
        if($bc==0 && $cc==0) {
	    print '$c->create("rectangle"'; 
	    &points($points[0],$points[1]); 
	    &points($points[2],$points[3]); 
        } else {
	    print '$c->create("',$area_fill?"polygon":"line",'"'; 
	    &points($points[0],$points[1]); 
	    &points($points[0],$points[3]); 
	    &points($points[2],$points[3]); 
	    &points($points[2],$points[1]); 
	    &points($points[0],$points[1]) if (! $area_fill); 
        }
        $larrow = $farrow = 0;
        &linetype;
     } elsif($type eq 'Elli'||$type eq 'Circ') {
        if($brush eq 'n' && ! $area_fill ) { next; }
        $_ = <>;
        if($type eq 'Elli') {
	    ($x,$y,$rx,$ry) = /$d $d $d $d Elli/o;
        } else {
	    ($x,$y,$rx) = /$d $d $d Circ/o; $ry = $rx;
        }
        print '$c->create("oval"'; 
        if($bc==0 && $cc==0) {
	    &points($x-$rx,$y-$ry);
	    &points($x+$rx,$y+$ry); 
        } else {
            # support no rotated ellipse, but rotated circle (ha!)
	    ($x,$y) = (int($ac*$x + $cc*$y + $xc),int($bc*$x + $dc*$y + $yc));
            $r = ($ac * $dc - $bc * $cc) * $rx * $ry;
            $r = int(sqrt(($r>0)?$r : - $r));
            print ',',$x-$r,',',$y-$r,',',$x+$r,',',$y+$r; 
        }
        $larrow = $farrow = 0;
        &linetype;
     }
     print ");\n";
     $type = '';
     while(<>) { print "### $_" if $debug; 
        last if (/^End/); 
     }
  } elsif (/^%%EndComments/) {
     &initCord;
     # skip header part (quite long)
     while(<>) {
        last if (/^%%EndProlog/);
     }
  } 
# else { print; print "\n"; }
}

&footer;

# subroutines

sub initCord {
#    $xoffset = -200; $yoffset = 1000; $scale = 2;
    $xoffset = -200; $yoffset = 1000; $scale = 3;
    ($ac,$bc,$cc,$dc,$xc,$yc) = 
    ($ab,$bb,$cb,$db,$xb,$yb) = ($scale,0,0,-$scale,$xoffset,$yoffset);
}

sub points {
   local($x,$y) = @_;
   # Translate cordinates using current translation
   #    x1 = a*x+c*y+x0
   #    y1 = b*x+d*y+y0
   local($x1) = int($ac*$x + $cc*$y + $xc);
   local($y1) = int($bc*$x + $dc*$y + $yc);
   # $bb[0] = $x1 if ($x1 < $bb[0]);
   # $bb[1] = $y1 if ($y1 < $bb[1]);
   # $bb[2] = $x1 if ($x1 > $bb[2]);
   # $bb[3] = $y1 if ($y1 > $bb[3]);
   print ",$x1,$y1";
}

sub linetype {
   if($farrow && $larrow) { print ',-arrow=>"both"';
   } elsif($farrow) {       print ',-arrow=>"first"';
   } elsif($larrow) {       print ',-arrow=>"last"';
   }
   if($lwidth > 1) {        print ",-width=>\"$lwidth\"";         
   } 
   if($pattern eq 'none') { # print ",-fill=>{}";  This display nothing
   } elsif ($pattern eq 'nosuuport') {
   } elsif ($pattern==0) {  print ",-fill=>$front_color"; 
   } elsif ($pattern==1) {  print ",-fill=>$back_color";
   } else {                 print ",-fill=>$front_color,-stipple=>\"gray50\"";
   }
   print ',-tag=>["',join('","',@tags),'"]' if(@tags);
}

sub color { 
    local($red,$blue,$green) = @_;
    return sprintf('"#%02x%02x%02x"',
	int($red*255) , 
	int($blue*255) , 
	int($green*255)) ;
}

sub header {
print <<'EOF';
#!/usr/local/bin/perl5 -w

use Tk;

$tktop = MainWindow->new();
$w = $tktop->Frame;
$c = $w->Canvas( -bg=>'white');
$wsy = $w->Scrollbar( -relief=>"sunken", -command=>[$c,"yview"])->pack;
$wsx = $w->Scrollbar( -orient=>"horiz", -relief=>"sunken",-command=>[$c,"xview"])->pack;
$w->pack(-expand=>"yes",-fill => "both");
$c->configure(-xscrollcommand => ['set', $wsx], -yscrollcommand => ['set', $wsy]);
$wsy->pack(-side => 'right', -fill => 'y');
$wsx->pack(-side => 'bottom', -fill => 'x');
$c->pack(-expand => 'yes', -fill => 'both');

#scrollbar $w.vscroll  
#scrollbar $w.hscroll 

$tktop->Button(-text=>'Ok',-command=>sub{$tktop->destroy})
      ->pack(-side=>'left',-expand=>1);
$tktop->Button(-text=>'Enlarge',-command=>sub{scale($c,1.6)})
      ->pack(-side=>'left',-expand=>1);
$tktop->Button(-text=>'Shrink',-command=>sub{scale($c,0.625)})
      ->pack(-side=>'left',-expand=>1);

sub scale {
    local ($c,$scale) = @_;
    local ($w,$h) = ($c->geometry =~ /\d+x\d+([+-]\d+)([+-]\d+)/);
    local ($s) = $c->cget(-scrollregion);
    local ($x,$y) = ($c->canvasx($w/2),$c->canvasy($h/2));
    $s->[0] = ($s->[0]-$x)*$scale+$x;
    $s->[1] = ($s->[1]-$y)*$scale+$y;
    $s->[2] = ($s->[2]-$x)*$scale+$x;
    $s->[3] = ($s->[3]-$y)*$scale+$y;
    $c->configure(-scrollregion=>$s);
    $c->scale('all', $x,$y,$scale,$scale);
}

# start idraw data

EOF
}

sub footer {
  print "\$c->configure(-scrollregion=>\[",join(",",@bb1), "\]);\n";
print <<'EOF';
#
$tktop->MainLoop;
EOF
}

# end
