#!/usr/local/bin/perl
#
# $Id: tgif5idraw.pl,v 1.14 2007/08/18 00:39:51 kono Exp $
#
use strict;
#
# Convert tgif format to idraw format
#
#  Author: Shinji Kono
#** Ϣ衧 ΰؾ󹩳ز    
# ** E-Mail Address: kono@ie.u-ryukyu.ac.jp
#
#**    ΥΤʤʣ̡ѡޤ
#**    κݤˤϡï׸򼨤ʬĤȡ
#**    ۤ仨Ͽʤɤ䤤碌ɬפޤ
#**    Ѥ嵭ȿʤϰϤǵĤޤ
#**    ΥץˤĤƤä˲ݾڤ⤷ʤ餺
#**
#**    Everyone is permitted to do anything on this program
#**    including copying, modifying, improving,
#**    as long as you don't try to pretend that you wrote it.
#**    i.e., the above copyright notice has to appear in all copies.
#**    You don't have to ask before copying, redistribution or publishing.
#**    THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE.

# ̤ΰ֤Ĵ
# my $xoffset = 50;
# my $yoffset = 350;
my $xoffset = 0;
my $yoffset = 400;

# gnuplotʤɤû򤤤äѤϤΤǤʤ٤ĤʤϤ򤹤롣
# Τ˻ȤХåե@mlineȤ
my ($polygon,$line_style,$thickness,$spline,
     $forward_arrow,$backward_arrow,$area_fill);

my (@pos);
my (@mline) = 
    ($polygon='poly',$line_style=1,$thickness=1,$spline=0,
     $forward_arrow=0,$backward_arrow=0,$area_fill=0);
my ($prev,$prev1);

my (@stack); # not used

my %color_info;
my $color_setup = <<"EOF";
%I cfg Black
0 0 0 SetCFg
%I cbg White
1 1 1 SetCBg
EOF
chop($color_setup);

sub main {
    &premble;       # IdrawΥإåɽ

    $/ = "\.\n";
    $* = 1;
    while(<>) {
       s/^%.*$//g;
       s/\"\"([]\),])/\'\'\1/g;
       s/\"\"/\\\"/g;
       chop;
       chop;
       print eval "\&$_";
       print &flush_mline if ($#pos>0);
    }

    &postemble;
}

sub group {
    my ($args) = @_;
    my $buf;
# $ctm?
    $buf = << "EOF";
Begin %I Pict
%I b u
%I cfg u
%I cbg u
%I f u
%I p u
%I t
[ 1 0 0 1 0 0 ] concat

EOF
    $buf .= join("\n",@$args);
    $buf .= &flush_mline;
    $buf .= << "EOF";
End %I eop

EOF
    $buf;
}

sub color_info {
    my ($dm,$max,$dm3,$arg) = @_;
# color_info(240,65535,0,[
#         "magenta", 65535, 0, 65535, 65535, 0, 65535, 1,
#         "red", 65535, 0, 0, 65535, 0, 0, 1,
#         "green", 0, 65535, 0, 0, 65535, 0, 1,
#         "blue", 0, 0, 65535, 0, 0, 65535, 1,
#         "yellow", 65535, 65535, 0, 65535, 65535, 0, 1,

    $max *= 1.0;
    while(@$arg) {
	my ($color,
               $r,$g,$b,$r1,$g1,$b1,$f
	    ) = splice(@$arg,0,8);
        $color_info{$color} = [$r/$max,$g/$max,$b/$max];
    }
    "";
}

sub set_color
{
    my ($color) = @_;
    if (defined($color_info{$color})) {
	my ($r,$g,$b) = @{$color_info{$color}};
	$color_setup = <<"EOF";
%I cfg Black
$r $g $b SetCFg
%I cbg White
1 1 1 SetCBg
EOF
    } else {
	$color_setup = <<"EOF";
%I cfg Black
0 0 0 SetCFg
%I cbg White
1 1 1 SetCBg
EOF
    }
    chop($color_setup);
}

sub check_transform {
    return "%I t u" unless (ref($_[0]));
    my (
$origX,$origY,
$origOBBoxLtX,$origOBBoxLtY,$origOBBoxRbX,$origOBBoxRbY,
$cTM_SX,$cTM_SIN,$cTM_MSIN,$cTM_SY,$cTM_TX,$cTM_TY) = @{$_[0]};
    return "%I t u" if ($#{$_[0]}<4 || !defined($cTM_TX));

    $cTM_SX /= 1000.0;$cTM_SIN /= 1000.0;
    $cTM_MSIN /= 1000.0;$cTM_SY  /= 1000.0;

    return "%I t\n[$cTM_SX $cTM_SIN $cTM_MSIN $cTM_SY $cTM_TX $cTM_TY] concat";

}

sub polygon {
    $polygon = 'polygon';
    &polyline(@_);
}
sub poly {
    $polygon = 'poly';
    &polyline(@_);
}

sub polyline {
    # poly('black',4,[
    #         368,288,464,240,448,352,512,336],1,1,1,33,0,0,0,0,8,3,0,[
    # ]).
    my ($color,$dm,$points,@arg) = @_;
    my $buf;
    while (@arg && ! ref($points)) {
        $points = shift(@arg);
    }
    &set_color($color);
    my ($ctm) = &check_transform($polygon eq 'poly'?$arg[18]:$arg[13]);
  # ޤޤ
    my @pos1 = @$points;
    $area_fill = ($polygon eq 'polygon')?$arg[0]:$arg[5];
    if ($polygon eq 'poly' && $area_fill) {
	$polygon = 'polygon';
        $forward_arrow = $backward_arrow = 0;
        $thickness = $arg[1]; $line_style = $arg[6]; $spline = $arg[3];
    } elsif($polygon eq 'polygon') { 
        pop(@pos1);pop(@pos1); 
        $forward_arrow = $backward_arrow = 0;
        $thickness = $arg[1]; $line_style = $arg[2]; $spline = $arg[3];
    } else { 
	if ($polygon eq 'poly') {
	    $forward_arrow = (($arg[0]&2)?1:0); $backward_arrow = ($arg[0]&1); 
	    $thickness = $arg[1]; $line_style = $arg[6]; $spline = $arg[4];
	} else {
	    $forward_arrow = $backward_arrow = 0;
	    $thickness = $arg[1]; $line_style = $arg[5]; $spline = $arg[4];
	}
    }
    if($polygon eq $mline[0] && $#pos>0 && $#pos<255 
        && $pos1[0] == $prev1 && $pos1[1] == $prev) {
        push(@pos,@pos1);
    } else {
       if ($#pos>0)  {
         $buf = &flush_mline;
       } 
       push(@pos,@pos1);
    }
    @mline = 
    ($polygon,$line_style,$thickness,$spline,
     $forward_arrow,$backward_arrow,$area_fill,$ctm);
    $prev = pop(@pos); $prev1 = pop(@pos);
    $buf;
}

sub arc {
    # arc('black',  0,1,1,0,227,67,320,160,400,112,352,240,1,186,186,1920,-6272,39,0,1,8
    # ,3,0,[
    # ]).
# new version
# 27:arc('black','',2,1,1,0,84, 61,101,79, 97,  97,119,74, 0,34,36,-6720,7680,4,0,0,8,3,
# 0,0,0,'1','8','3',0,[
# 28:]),

    my ($color,@arg) = @_;
    my ($buf);
  # μ갷
    &set_color($color);
    my ($ctm) ;
    my ($xc,$yc,$x0,$y0,$x1,$y1,$direction) ;

    if ($arg[0] !~ /[0-9]/) {
	shift(@arg);
	$ctm = &check_transform($arg[15]);
	$area_fill = $arg[0];
        $forward_arrow = (($arg[19]&2)?1:0); $backward_arrow = ($arg[19]&1); 
	$thickness = $arg[1]; $line_style = $arg[3]; $spline = 1;
	($xc,$yc,$x0,$y0,$x1,$y1,$direction) = @arg[6..12];
	$buf = &flush_mline;
	$polygon = 'poly';
   # $x2, $y2 is some how wrong... recalcurate
       my ($x10,$y10,$x12,$y12) = 
	   ($x0-$xc,$y0-$yc,$x1-$xc,$y1-$yc);
       my $r = $x10 * $x10 + $y10 * $y10;
	($x1,$y1) = &normalize($x12,$y12,$r,$xc,$yc);
	@pos = &arc_out($xc,$yc,$x0,$y0,$x1,$y1,$direction);
        # @pos = &arc_out($xc,$yc,$x0,$y0,$x1,$y1,$direction); $spline = 0; # for debug
    } else {
    $area_fill = $arg[0];
    $forward_arrow = (($arg[0]&2)?1:0); $backward_arrow = ($arg[0]&1); 
    $thickness = $arg[1]; $line_style = $arg[3]; $spline = 1;
    $ctm = &check_transform($arg[18]);
#                          0        1          2       3     4    5    6  7
#        Obj = arc(_Color,_ObjFill,_LineWidth,_PenPat,_Dash,_LtX,_LtY,_Xc,_Yc,
#                 8   9   10  11  12
#                _X1,_Y1,_X2,_Y2,_Dir,_W,_H,_Angle1,_Angle2,_Id,_Rotation,
#                _Style,_ArrowHeadW,_ArrowHeadH,_Locked,AttrList),

    ($xc,$yc,$x0,$y0,$x1,$y1,$direction) = @arg[6..12];
#    ϰʲƱ
#    $xc = $arg[6]; $yc = $arg[7]; $x0 = $arg[8]; $y0 = $arg[9];
#    $x1 = $arg[10]; $y1 = $arg[10];
#    $direction = $arg[11]; 

	$buf = &flush_mline;
	$polygon = 'poly';
	@pos = &arc_out($xc,$yc,$x0,$y0,$x1,$y1,$direction);
    #    @pos = &arc_out($xc,$yc,$x0,$y0,$x1,$y1); $spline = 0; # for debug
    }
    @mline = 
    ($polygon,$line_style,$thickness,$spline,
     $forward_arrow,$backward_arrow,$area_fill,$ctm);
    $prev = pop(@pos); $prev1 = pop(@pos);
    $buf;
}

sub rcbox { &box(@_); }

sub box {
    my ($color,@arg) = @_;
    my ($buf);
  # Ĺμ갷
    &set_color($color);
    while ($arg[0] !~ /[0-9]/ ) {
        shift(@arg);
    }
    my $ctm = &check_transform($arg[15]);
    my $rect = join(" ",$xoffset+$arg[0],$yoffset-$arg[1],
                     $xoffset+$arg[2],$yoffset-$arg[3]);
    ($forward_arrow,$backward_arrow,$area_fill) = (0,0,$arg[4]);
    $buf = "Begin %I Rect\n";
    $line_style = 0;
    $buf .= &style($line_style,$thickness,$forward_arrow,$backward_arrow,$area_fill,$ctm);

    $buf .= <<"EOF";
%I
$rect Rect
End
EOF
    $buf;
}

sub oval {
    my ($color,@arg) = @_;
    my ($buf);
  # ߤΰ
    &set_color($color);
    while ($arg[0] !~ /[0-9]/ ) {
        shift(@arg);
    }
    my $ctm = &check_transform($arg[15]);
    my $elli = join(" ",
            ($xoffset+($arg[0]+$arg[2])/2, 
             $yoffset-($arg[1]+$arg[3])/2, 
             ($arg[2]-$arg[0])/2, ($arg[3]-$arg[1])/2));
    my ($line_style,$thickness,$forward_arrow,$backward_arrow,$area_fill)
	= ($arg[8],$arg[13],0,0,$arg[4]);
    $buf = "Begin %I Elli\n";
    $buf .= &style($line_style,$thickness,$forward_arrow,$backward_arrow,$area_fill,$ctm);
    $buf .= <<"EOF";
%I
$elli Elli
End

EOF
    $buf;
} 

sub text {
  # ƥ
# text('black',96,144,1001,0,4,1,0,0,1,90,20,26,0,16,4,0,0,0,0,[
#        "ǡ"]).
    my ($color,@arg) = @_;
    my $buf;
    while ($arg[0] !~ /[0-9]/ ) {
        shift(@arg);
    }
    &set_color($color);
    my $ctx = &check_transform($arg[15]);
    my @text = ();
    my $x = $arg[0]; my $y = $arg[1];

    my $texts = $arg[$#arg];
    @text = @{$texts};
    foreach (@text) {
      while($_ ne '') {
      # ɤǽ櫓ʤȤʤ
	if(s/^[\000-\177]+//) {
	  my $text = $&; my $kanji = 0;
	  my $xfont = "-*-times-medium-r-normal--14-*-iso8859-1";
	  my $psfont = "Times-Roman"; my $font_size = 14; 
	  $buf .= &text_out($text,$arg[0],$arg[1],$ctx,$psfont,$xfont,$font_size,$kanji);
           $arg[0] += $font_size * length($text)/2;
	} elsif(s/^[\200-\377]+//) {
	  my $text = $&; my $kanji = 1;
	  my $xfont = "-*-fixed-medium-r-normal--14-*-jisx0208.*-0";
	  my $psfont = "Ryumin-Light-H"; my $font_size = 14;
	  $buf .= &text_out($text,$arg[0],$arg[1],$ctx,$psfont,$xfont,$font_size,$kanji); 
	  $arg[0] += $font_size * length($text)/2;
	}
      }
      $arg[1] += 14; $arg[0] = $x;
    }
    $buf;
}

sub minilines {
# minilines(32,18,0,0,0,0,0,[
    while (@_ && ! ref($_[0])) {
        shift(@_);
    }
    join("",@{$_[0]});
}

sub mini_line {
# mini_line(32,13,5,0,0,0,[
    while (@_ && ! ref($_[0])) {
        shift(@_);
    }
    join("",@{$_[0]});
}

sub str_block {
# str_block(0,32,13,5,0,-1,0,0,0,[
    while (@_ && ! ref($_[0])) {
        shift(@_);
    }
    join("",@{$_[0]});
}

sub str_seg {
# str_seg('black','Courier',0,80640,32,13,5,0,-1,0,0,0,0,0,
#         "test")])
    my $t = $_[$#_];      # to avoid variable suiside
    $t;
}

#   tgifü쵡ǽŬˤޤ
#   ʤǽ񤤤Ƥ
sub state {
    push(@stack,'state'); '';
}

sub attr {
    push(@stack,'attr'); '';
}



sub text_out {
    my ($text,$x,$y,$ctm,$psfont,$xfont,$font_size,$kanji) = @_;
    if($text eq '') {return;}
    my $position = ($xoffset+$x) . " " . ($yoffset-$y);
    $text =~ tr/\200-\377/\000-\177/ if ($kanji);
    $text =~ s/[()\\]/\\$&/g;
## $ctm?
    return <<"EOF";
Begin %I Text
$color_setup
%I f $xfont
$psfont $font_size SetF
%I t
[ 1 0 0 1 $position ] concat
%I
[
($text)
] Text
End

EOF
}

sub style {
    my ($line_style,$thickness,$forward_arrow,$backward_arrow,$area_fill,$ctm) = @_;
    # °ϤƽϤ
    my ($style,$stylev);
    if($line_style % 6==1) { $style = '4 4 4 4'; $stylev = 3855;
    } elsif($line_style % 6==2) { $style = '2 2'; $stylev = 13107;
    } else { $style = ''; $stylev = 65535;
    }
    print '%%%%% ($line_style,$thickness,$forward_arrow,$backward_arrow,$area_fill,$ctm) = ',"($line_style,$thickness,$forward_arrow,$backward_arrow,$area_fill,$ctm)\n";
    my $brushtype = "%I b $stylev\n" . 
    "$thickness $forward_arrow $backward_arrow [$style] 0 SetB";
    my $setpen;
    if($area_fill==1) {
	    # solid pattern 
           $setpen = "%I p\n$area_fill SetP";
    } elsif($area_fill>0) {
           $area_fill = 1 - ($area_fill / 21);
           if($area_fill<0)  {$area_fill = 0;}
           if($area_fill>=1) {$area_fill = 1;}
           $setpen = "%I p\n$area_fill SetP";
    } else {
           $setpen = "none SetP %I p n";
    }
    return <<"EOF";
$brushtype
$color_setup
$setpen
$ctm
EOF
}

# ޤäʬ򤤤äڤ˽Ϥ
sub flush_mline {
    my ($buf);
    return '' if (! ($#pos>0));   # ޤäƤʤä
    my ($polygon,$line_style,$thickness,$spline,
        $forward_arrow,$backward_arrow,$area_fill,$ctm) = @mline;
    # $spline==1  Bezier ˤʤΤǡɬ
    my $mline = ($polygon eq 'polygon')?
                 ($spline?'CBSpl':'Poly'):
                 ($spline?'BSpl':'MLine');
    $buf = "Begin %I $mline\n";
    $buf .= &style($line_style,$thickness,$forward_arrow,$backward_arrow,$area_fill,$ctm);
    if ($spline==1 && $polygon eq 'polygon') {
	# convert bezier to spline
        my @new;
	push(@pos,$prev1); push(@pos,$prev);
	my ($x1,$y1) = ($prev1,$prev);
        while(@pos) {
	    my ($x,$y) = (shift(@pos),shift(@pos));
	    push(@new,($x1+$x)/2,($y1+$y)/2);
	    ($x1,$y1) = ($x,$y);
        }
	@pos = @new;
    } elsif ($spline==1 && $polygon eq 'poly') {
	# not convert bezier to spline (?)
	push(@pos,$prev1);
	push(@pos,$prev);
    } else {
	# λĤ꤫Ϥ
	push(@pos,$prev1);
	push(@pos,$prev);
    }
    my $count = int(($#pos+1)/2);
    $buf .= "%I ".$count."\n";
    # 
    for(my $i=0;$i<$count;$i++) {
      $buf .= int($xoffset+shift(@pos)).' '.
            int($yoffset-shift(@pos))."\n";
    }
    if($polygon eq 'polygon') {
      $buf .= $count." $mline\nEnd\n\n";
    } else {
      $buf .= $count." $mline\n%I 1\nEnd\n\n";
    }
    $buf;
#    $#pos = $[;
}

sub normalize {
    my ($x,$y,$r2,$xc,$yc) = @_;
    my ($r) = sqrt($r2)/sqrt($x*$x+$y*$y);
    ($x*$r+$xc,$y*$r+$yc);
}

# IdrawϥʤΤǡøʶǤޤ
sub arc_out {
   my ($xc,$yc,$x0,$y0,$x2,$y2,$direction) = @_;
   my ($r,$x,$y,$xm,$ym);

   # approximate 3point arc with center by open spline
   ($x0,$y0,$x2,$y2) = 
       ($x0-$xc,$y0-$yc,$x2-$xc,$y2-$yc);
   $r = $x0 * $x0 + $y0 * $y0;
   # calculate mid point
   $y = $y2-$y0; $x = $x2-$x0;
   $xm = sqrt($r/($y*$y+$x*$x));
   $ym = $xm*$x; $xm = -$xm*$y;
   if($direction) { $xm= -$xm; $ym = -$ym; }
   return (  ($x0+$xc,$y0+$yc, 
              &arc3($x0,$y0,$xm,$ym,$r,$xc,$yc),
	      &arc3($xm,$ym,$x2,$y2,$r,$xc,$yc), 
              $x2+$xc,$y2+$yc));
}

sub arc3 {
   my ($x0,$y0,$x1,$y1,$r,$xc,$yc) = @_;
   my ($d,$e,$f);
   $e = sqrt($r*(($y1-$y0)*($y1-$y0)+($x1-$x0)*($x1-$x0)));
   $d = $x0*$y1-$x1*$y0; $f = ($d>0)?1:-1;
   return ( 
	&normalize(
      ($r*($y1-$y0)*$f+$x0*$e)/($d*$f+$e) ,
      ($r*($x0-$x1)*$f+$y0*$e)/($d*$f+$e),$r,$xc,$yc), 
	&normalize(
      ($r*($y1-$y0)*$f+$x1*$e)/($d*$f+$e),
      ($r*($x0-$x1)*$f+$y1*$e)/($d*$f+$e),$r,$xc, $yc));
}



sub postemble {
print <<'EOF';
End %I eop

showpage

%%Trailer

end
EOF
}

sub premble {
print <<'EOF';
%I Idraw 10 Grid 8 8 

%%Page: 1 1

EOF
print <<"EOF";
Begin
%I b u
%I cfg u
%I cbg u
%I f u
%I p u
%I t
[ 0.717045 0 0 0.717045 $xoffset $yoffset ] concat
/originalCTM matrix currentmatrix def

EOF
}

&main();

# end
