#!/usr/local/bin/perl
#
# $Id: xfig2idraw.pl,v 1.2 2003/06/30 00:44:15 kono Exp $
#
# Convert xfig format to idraw format
#
#  Author: Shinji Kono
#** AF wHw ͖ ^  
# ** iE-Mail Address: kono@ie.u-ryukyu.ac.jpj
#
#**    ̃\[X̂Ȃ镡ʁCρCC܂BA
#**    ̍ۂɂ́ANv̕cƁB
#**    ĔzzG̕t^Ȃǂ̖₢킹Kv܂B
#**    cpLɔȂ͈͂ŋ܂B
#**    ̃vOɂĂ͓ɉ̕ۏ؂ȂA炸B
#**
#**    Everyone is permitted to do anything on this program
#**    including copying, modifying, improving,
#**    as long as you don't try to pretend that you wrote it.
#**    i.e., the above copyright notice has to appear in all copies.
#**    You don't have to ask before copying, redistribution or publishing.
#**    THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE.


$xoffset = 150;
$yoffset = 700;

$d = '([-0-9.]+)';
$textpattern =  '[-0-9.]+\\s+' x 13;
$currentx = 0; $currenty = 0;
$forward_arrow =  $backward_arrow = 0;
$_ = <>;
/^#FIG/ || die("Is this really fig file?");
$xfig = $1; 
$_ = <>; ($resolution, $coordinate) = /$d $d/o;

&header;
&init_fonts;

while(<>) {
    /^#/ && next;
    ($type,@data) = split;       # XfigtH[}bg͂ŉ͏I
    @farrow = (); @barrow = ();
    $thickness = $currentx = $currenty = 0;
    $area_fill = 0; $forward_arrow =  $backward_arrow = 0;
    # Ƃ̓^Cvʂɏ
    if($type == 6) { # Begin Compound
        # }`̃O[vB͂̂܂IdrawɂB
	($upperright_corner_x, $upperright_corner_y,
	$lowerleft_corner_x, $lowerleft_corner_y) = @data;
	$lowerleft_corner_y *= -1;
        print <<"EOF";
Begin %I Pict
%I b u
%I cfg u
%I cbg u
%I f u
%I p u
%I t u
EOF
    } elsif($type == -6) { # End Compound
        print "End %I eop\n\n";
    } elsif($type == 1) { # Ellipse
        $subtype = shift(@data);
	#1 : ellipse defined by radiuses
	#2 : ellipse defined by diameters
	#3 : circle defined by radius
	#4 : circle defined by diameter
	($line_style, $thickness, $color	, $depth	,
	$pen	, $area_fill, $style_val, $direction, $angle	,
	$center_x, $center_y, $radius_x, $radius_y, $start_x, $start_y,
	$end_x, $end_y	) = @data;
        if($angle != 0.0) {       # ]ȉ~]svZ
	    $at = cos($angle);  $bt = sin($angle);
	    $ct = -sin($angle); $dt = cos($angle);
        } else {
            ($at,$bt,$ct,$dt) = (1,0,0,1);  # Pʍsł
        }
        # vZ
        if($line_style == 1) { $style = '4 4 4 4'; $stylev = 3855;
        } elsif($line_style == 2) { $style = '2 2'; $stylev = 13107;
        } else { $style = ''; $stylev = 65535;
        }
        $brushtype = "%I b $stylev\n" . 
           "$thickness $forward_arrow $backward_arrow [$style] 0";
        if($area_fill>0) {
           $area_fill = 1 - ($area_fill / 21);
           if($area_fill<0)  {$area_fill = 0;}
           if($area_fill>=1) {$area_fill = 1;}
           $setpen = "%I p\n$area_fill SetP";
        } else {
           $setpen = "none SetP %I p n";
        }
	$center_y *= -1;
        print <<"EOF";
Begin %I Elli
$brushtype SetB
%I cfg Black
0 0 0 SetCFg
%I cbg White
1 1 1 SetCBg
$setpen
%I t
[ $at $bt $ct $dt $currentx $currenty ] concat
%I
$center_x $center_y $radius_x $radius_y Elli
End

EOF
    } elsif($type == 2 || $type == 3 || $type == 5) { # Poly line or Spline
        # ȉ̂̂܂Ƃ߂ď悤
        $subtype = shift(@data); $type = $type * 10 + $subtype;
	#21 : polyline
	#22 : box
	#23 : polygon
	#24 : arc-box
	#25 : imported-eps bounding-box
	#31 : open spline
	#32 : closed spline
	#33 : open interpolated spline
	#34 : closed interpolated spline)
        #51 : arc
        # ǁAƂŁA
        if($type == 25) {
           ($dm,$flipped,$file) = split(<>);
        }
        if($type < 30) {  # poly
	    ($line_style, $thickness, $color	, $depth	,
	    $pen	, $area_fill, $style_val, $radius) = @data;
	    $forward_arrow = $data[$#data]; $backward_arrow = $data[$#data-1]; 
        } elsif ($type < 50) { # spline
	    ($line_style, $thickness, $color	, $depth	,
	    $pen	, $area_fill, $style_val) = @data;
	    $forward_arrow = $data[$#data]; $backward_arrow = $data[$#data-1]; 
            $type++; 
        } else {          # arc
	    ($line_style, $line_thickness,
	    $color, $depth, $pen, $area_fill, $style_val, $direction,
	    $forward_arrow, $backward_arrow, $center_x, $center_y,
	    @points) = @data;
	    # not support on idraw, make better approximation by spline
	    @points = &arc($center_x,$center_y,@points);
            if($direction) {
	      ($forward_arrow, $backward_arrow) =
              ($backward_arrow,$forward_arrow);
            }
        }
        if($forward_arrow)  { @farrow = split(<>); }
        if($backward_arrow) { @barrow = split(<>); }
        if($line_style == 1) { $style = '4 4 4 4'; $stylev = 3855;
        } elsif($line_style == 2) { $style = '2 2'; $stylev = 13107;
        } else { $style = ''; $stylev = 65535;
        }
        $brushtype = "%I b $stylev\n" . 
           "$thickness $forward_arrow $backward_arrow [$style] 0";
        if($area_fill>0) {
           $area_fill = 1 - ($area_fill / 21);
           if($area_fill<0)  {$area_fill = 0;}
           if($area_fill>=1) {$area_fill = 1;}
           $setpen = "%I p\n$area_fill SetP";
        } else {
           $setpen = "none SetP %I p n";
        }
        # _̕ѕႤ()
        if($type < 50) {
            @points = ();
	    while(<>) { chop; s/^\s+//;
              push(@points,split);
	      $points[$#points]==9999 &&
	      $points[$#points-1]==9999 && last;
	    }
            $#points -= 2;
        }
        # `悵₷_̕g
        if($type==33) {  # use control points
               $_ = <>; chop; s/^\s+//; 
               @buf = split;
	       shift(@buf);shift(@buf);
	       pop(@buf);pop(@buf);
               @points =  ($points[0],$points[1],@buf,
                   $points[$#points-1],$points[$#points]);
        # Idraw͕ȐɍŌ̓_Ȃ(ƍ̂ł̂)
        } elsif($type==34) {  # use control points
               $_ = <>; chop; s/^\s+//; 
               @points = split; 
	       shift(@points);shift(@points);
	       pop(@points);pop(@points);
        }elsif($type==32) { pop(@points);pop(@points);
        }
	$count = int($#points / 2)+1;
        $poly = ($type >30)?(($type&1)?'BSpl':'CBSpl'):'MLine';
        if($currentx == 0 && $currenty ==0) {
          $translate = '%I t u';
        } else {
          $translate = "%I t\n[ 1 0 0 1 $currentx $currenty ] concat";
        }
        print <<"EOF";
Begin %I $poly
$brushtype SetB
%I cfg Black
0 0 0 SetCFg
%I cbg White
1 1 1 SetCBg
$setpen
$translate
%I $count
EOF
        print int(shift(@points)),' ',
              int(- shift(@points)),
              "\n" while(@points);
        print "$count $poly\n";
        print "%I 1\n" if ($poly eq 'BSpl' || $poly eq 'MLine');
        print "End\n\n";
    } elsif($type == 4) { # Text
        $subtype = shift(@data);
	#0 : Left justified
	#1 : Center justified
	($font, $font_size, $pen, $color,
	$depth, $angle, $font_flags, $height	,
	$length	, $x, $y) = @data;
        chop;
        s/^\s*$textpattern//o;
        $string = $_;
	if( ! ($string =~ s/\001$//)) {  # sɂ킩Ă̂
	    while(<>) {
	       last if(s/\001$//);
	       $string .= $_;            # ȂĂ
	    }
	    $string .= $_;
        }
        $string =~ s/[()]/\\$&/g;
        if($angle != 0.0) {   # ]̏
	    $at = cos($angle);  $bt = sin($angle);
	    $ct = -sin($angle); $dt = cos($angle);
        } else {
            ($at,$bt,$ct,$dt) = (1,0,0,1);
        }
        if($subtype eq 1) {
           $x -= $length /2;
        } elsif ($subtype eq 2) {
           $x -= $length;
        }
        $y = - ($y - $height);
        if($x == 0 && $y ==0) {
          $translate = '%I t u';
        } else {
          $translate = "%I t\n[ $at $bt $ct $dt $x $y ] concat";
        }
        if($string =~ /[\200-\376]/ ) {  # ʈ
            $string =~ tr/\200-\376/\000-\176/;
            $xfont = "-*-fixed-medium-r-normal--14-*-jisx0208.*-0";
          $psfont = "Ryumin-Light-H";
            $font_size = 14;
        } else {    # ԍtHgɕϊ
          $xfont =  $xfonts[$psfonts[$font * 2 + 1]];
          if(! $xfont) { $xfont = $xfonts[0]; }
          if($font_size<1) { $font_size = 10; }
          if($font_size==13) { $font_size = 14; } # nnn...
          $xfont .= $font_size  . '-*';
          $psfont = $psfonts[$font * 2];
        }
	print <<"EOF";
Begin %I Text
%I cfg Black
0 0 0 SetCFg
%I f $xfont
$psfont $font_size SetF
$translate
%I
[
($string)
] Text
End

EOF
    }
}
&footer;

# Idraw̓A[NĂȂ̂łȋߎgƂɂ

sub arc {
   local($xc,$yc,$x0,$y0,$x1,$y1,$x2,$y2) = @_;
   local($r,$x,$y,$xm,$ym);

   #  return ($x0,$y0,$x1,$y1,$x2,$y2);  # no approximation
   # approximate 3point arc with center by open spline
   ($x0,$y0,$x1,$y1,$x2,$y2) = 
       ($x0-$xc,$y0-$yc,$x1-$xc,$y1-$yc,$x2-$xc,$y2-$yc);
   $r = $x1 * $x1 + $y1 * $y1;
   # recalculate mid point
   $y = $y2-$y0; $x = $x2-$x0;
   $xm = sqrt($r/($y*$y+$x*$x));
   $ym = $xm*$x; $xm = -$xm*$y;
   if((($ym-$y0)*$x-$y*($xm-$x0)) *
      (($y1-$y0)*$x-$y*($x1-$x0))<0) { $xm= -$xm; $ym = -$ym; }
   $x1 = $xm; $y1 = $ym;
   if(1) {    # six points approximation (good)
   return (  ($x0+$xc,$y0+$yc, 
#              $xm+$xc,$ym+$yc,
              &arc3($x0,$y0,$x1,$y1),&arc3($x1,$y1,$x2,$y2), 
              $x2+$xc,$y2+$yc));
   } 
}

sub arc3 {
   local($x0,$y0,$x1,$y1) = @_;
   local($d,$e,$f);
   $e = sqrt($r*(($y1-$y0)*($y1-$y0)+($x1-$x0)*($x1-$x0)));
   $d = $x0*$y1-$x1*$y0; $f = ($d>0)?1:-1;
   return ( 
      ($r*($y1-$y0)*$f+$x0*$e)/($d*$f+$e) + $xc,
      ($r*($x0-$x1)*$f+$y0*$e)/($d*$f+$e) + $yc,
      ($r*($y1-$y0)*$f+$x1*$e)/($d*$f+$e) + $xc,
      ($r*($x0-$x1)*$f+$y1*$e)/($d*$f+$e) + $yc);
}

# ̃tHg̖ÓAFORMAT2.1Ă̂ĂȂ̂ŁA
# xfig̃\[X(ufonts.c)玝ĂBX-Window̃tHgPostScript
# tHg̑gɂȂĂBXfig̃tH[}bg͖{͂̃tHg
# ܂łׂȂ̂낤B

sub init_fonts {
@xfonts = (
    "-adobe-times-medium-r-*--",
    "-adobe-times-medium-i-*--",
    "-adobe-times-bold-r-*--",
    "-adobe-times-bold-i-*--",
    "-schumacher-clean-medium-r-*--",
    "-schumacher-clean-medium-i-*--",
    "-schumacher-clean-bold-r-*--",
    "-schumacher-clean-bold-i-*--",
    "-adobe-courier-medium-r-*--",
    "-adobe-courier-medium-o-*--",
    "-adobe-courier-bold-r-*--",
    "-adobe-courier-bold-o-*--",
    "-adobe-helvetica-medium-r-*--",
    "-adobe-helvetica-medium-o-*--",
    "-adobe-helvetica-bold-r-*--",
    "-adobe-helvetica-bold-o-*--",
    "-abode-new century schoolbook-medium-r-*--",
    "-adobe-new century schoolbook-medium-i-*--",
    "-adobe-new century schoolbook-bold-r-*--",
    "-adobe-new century schoolbook-bold-i-*--",
    "-*-lucidabright-medium-r-*--",
    "-*-lucidabright-medium-i-*--",
    "-*-lucidabright-demibold-r-*--",
    "-*-lucidabright-demibold-i-*--",
    "*-symbol-medium-r-*--",
    "-*-zapfchancery-medium-i-*--",
    "-*-zapfdingbats-*-*-*--"
);

@psfonts = (
    "Times-Roman", 0,
    "Times-Italic", 1,
    "Times-Bold", 2,
    "Times-BoldItalic", 3,
    "AvantGarde-Book", 4,
    "AvantGarde-BookOblique", 5,
    "AvantGarde-Demi", 6,
    "AvantGarde-DemiOblique", 7,
    "Bookman-Light", 0,
    "Bookman-LightItalic", 0,
    "Bookman-Demi", 0,
    "Bookman-DemiItalic", 0,
    "Courier", 8,
    "Courier-Oblique", 9,
    "Courier-Bold", 10,
    "Courier-BoldOblique", 11,
    "Helvetica", 12,
    "Helvetica-Oblique", 13,
    "Helvetica-Bold", 14,
    "Helvetica-BoldOblique", 15,
    "Helvetica-Narrow", 0,
    "Helvetica-Narrow-Oblique", 0,
    "Helvetica-Narrow-Bold", 0,
    "Helvetica-Narrow-BoldOblique", 0,
    "NewCenturySchlbk-Roman", 16,
    "NewCenturySchlbk-Italic", 17,
    "NewCenturySchlbk-Bold", 18,
    "NewCenturySchlbk-BoldItalic", 19,
    "Palatino-Roman", 20,
    "Palatino-Italic", 21,
    "Palatino-Bold", 22,
    "Palatino-BoldItalic", 23,
    "Symbol", 24,
    "ZapfChancery-MediumItalic", 25,
    "ZapfDingbats", 26
);
}

sub header {
print <<'EOF';
%I Idraw 10 Grid 8 8 

%%Page: 1 1

EOF
print <<"EOF";
Begin
%I b u
%I cfg u
%I cbg u
%I f u
%I p u
%I t
[ 0.717045 0 0 0.717045 $xoffset $yoffset ] concat
/originalCTM matrix currentmatrix def

EOF
}


sub footer {
print <<'EOF';
End %I eop

showpage

%%Trailer

end
EOF
}

